package GMapViewer;
require CMONOS::TableMaker::TMCommon;
@ISA = qw(TMCommon);
use strict;
use utf8;
######################################################################
# Googleマップ表示モジュール
# GMapViewer.pm ver1.0.4
# Copyright (C) 1999-2012 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2012-05-05
######################################################################
# メイン
sub run ($) {
my $this = shift;
my($title,$has_coordinates,$search_form,$sc,$gmap_url,$gmap_z,$gmap_t,$gmap_c);


#---------------------------------------------------------------------
#承認待ち項目警告
$this->set_pending_item_alert if !defined $main::mod && !defined $main::w && !defined $main::s && $this->is_secure('tools');

#---------------------------------------------------------------------
#特殊フィールド処理
if (defined $main::c && $main::c ne '' && defined $main::n && $main::n ne '' && -d $default::db . '/' . $main::c && defined $main::id && $main::id ne '' && ref $field::obj{$main::id} && $field::obj{$main::id}->update_enabled && $field::obj{$main::id}->is_secure_user_for_update) {
	$field::obj{$main::id}->update;
	@main::c = (@main::ct) ? @main::ct : ($main::c);#特殊フィールド用の条件から元の条件を復元
	undef $main::c;
}


$this->replace_category_list;

#詳細条件欄
$has_coordinates = (defined $field::for{'coordinates'} && ref $field::obj{$field::for{'coordinates'}} && $field::obj{$field::for{'coordinates'}}->{'class'} && $field::obj{$field::for{'coordinates'}}->{'class'} eq 'webapi_gmap') ? 1 : 0;
foreach (sort {$a <=> $b} keys %field::ORDER) {
	my $id = $field::ORDER{$_};
	if (!$has_coordinates && $field::obj{$id}->{'class'} eq 'webapi_gmap') {
		$field::for{'coordinates'} = $id;
		$has_coordinates = 1;
	}
	next unless ref $field::obj{$id} && !$field::obj{$id}->{'Hidden'} && ($field::obj{$id}->{'Open'} || $this->is_secure('secret')) && $field::obj{$id}->{'searchEnabled'} && $field::obj{$id}->search_form_enabled && $field::for{'coordinates'} ne $id;
	$search_form .= $field::obj{$id}->search_form;
	$sc++;
}

#使用不可
if (!$has_coordinates) {
	$this->print_viewer_header;
	print '<p>座標フィールドがみつからないため、Googleマップを表示することができません。</p>';
	$this->print_viewer_footer;
	exit;
#} elsif ($sc && $setting::page{'gmap'}{'floatingSearchFormEnabled'} && $ENV{'HTTP_USER_AGENT'} !~ /(?:iPhone|iPod|Android|DoCoMo|KDDI|UP\.Browser|J-PHONE|Vodafone|SoftBank|MCONV)/) {
} elsif ($sc && $setting::page{'gmap'}{'floatingSearchFormEnabled'}) {
my $javascript = <<JAVASCRIPT;
cmonos.tool.gmapviewer = {
	floatingSearchForm : function () {
		var search_form = document.getElementById('search-form');
		if (search_form) {
			search_form.className = 'floating-search-form';
			search_form.style.position = (navigator.userAgent.indexOf("MSIE") != -1 && typeof document.documentElement.style.msInterpolationMode == "undefined") ? "absolute" : "fixed";
			var user_position = cmonos.document.getCookie("SEARCH_BOX_POSITION").split(/,/);
			if (user_position.length == 2) {
				search_form.style.left = (parseInt(user_position[0]) > 0) ? user_position[0] : 0;
				search_form.style.top = (parseInt(user_position[1]) > 0) ? user_position[1] : 0;
			} else {
				search_form.style.left = 120 + 'px';
				search_form.style.top = 120 + 'px';
			}
			var set_draggable = function () {
				cmonos.element.item(search_form).draggable(
					{
						endeffect	:	function(e) {
							cmonos.document.setCookie('SEARCH_BOX_POSITION',e.style.left + ',' + e.style.top);
						}
					}
				);
			};
			for (var i=0; i < search_form.elements.length; i++) {
				if (search_form.elements[i].type && search_form.elements[i].tagName.toLowerCase() != "fieldset" && search_form.elements[i].type.toLowerCase() != "hidden") {
					cmonos.element.item(search_form.elements[i]).addEventListener('mousedown',function(e) { cmonos.element.item().clearDraggable().dragDisabled(); });
					cmonos.element.item(search_form.elements[i]).addEventListener('focus',function(e) { cmonos.element.item(search_form).drawerDisabled(); });
					cmonos.element.item(search_form.elements[i]).addEventListener('mouseup',function(e) { cmonos.element.dragEnabled(); });
					cmonos.element.item(search_form.elements[i]).addEventListener('blur',function(e) { cmonos.element.drawerEnabled(); });
				}
			}
			var search_legend = document.getElementById('search-legend');
			if (search_legend) {
				this.toggle_button = document.createElement("a");
				this.toggle_button.innerHTML = '[-]';
				this.toggle_button.title = '折り畳む';
				this.toggle_button.className = 'closebox';
				search_legend.insertBefore(this.toggle_button,search_legend.firstChild);
				cmonos.element.item(this.toggle_button).addEventListener('click',function() { cmonos.tool.gmapviewer.toggleSearchForm(); });
				if (cmonos.document.getCookie("SEARCH_BOX_MINIMIZED") == "true") this.toggleSearchForm();
			}
			cmonos.element.item(search_form).addEventListener('dblclick',function() { cmonos.tool.gmapviewer.toggleSearchForm(); });
			set_draggable();
		}
	},

	toggleSearchForm : function () {
		var search_form = document.getElementById('search-form');
		var search_form_table = document.getElementById('search-field-table');
		if (this.toggle_button == null) return;
		if (search_form_table.style.display == null || search_form_table.style.display != 'none') {
			if (typeof search_form_table.style.setProperty == 'function') {
				search_form_table.style.setProperty('display','none','important');
			} else {
				search_form_table.style.display = 'none';
			}
			this.toggle_button.innerHTML = '[+]';
			this.toggle_button.title = '広げる';
			this.toggle_button.className = 'openbox';
			cmonos.document.setCookie('SEARCH_BOX_MINIMIZED','true');
		} else {
			search_form_table.style.display = '';
			this.toggle_button.innerHTML = '[-]';
			this.toggle_button.title = '折り畳む';
			this.toggle_button.className = 'closebox';
			cmonos.document.setCookie('SEARCH_BOX_MINIMIZED','false');
		}
	}
}
JAVASCRIPT
	$this->set_javascript($javascript);
	$this->set_onload('cmonos.tool.gmapviewer.floatingSearchForm();');
}
$this->set_onload('cmonos.form.item(\'search-form\').setSyncWith([\'tm-toolbox-top\',\'tm-toolbox-bottom\'])');

if ($main::c && (!$main::rc || $main::rc ne $main::c || ((!$main::mod || $main::mod ne 'GMapViewer') && !$main::gz && !$main::gc))) {
	$this->import_db($default::preference_dir . '/category',\%setting::category,1) if !%setting::category;
	if ($setting::category{$main::c}{'gmap'}) {
		$main::gz = $setting::category{$main::c}{'z'} if $setting::category{$main::c}{'z'};
		$main::gt = $setting::category{$main::c}{'t'} if defined $setting::category{$main::c}{'t'};
		$main::gc = $setting::category{$main::c}{'c'} if $setting::category{$main::c}{'c'};
	} else {
		$main::gz = ($setting::page{$setting::key}{'z'}) ? $setting::page{$setting::key}{'z'} : 4;
		$main::gt = ($setting::page{$setting::key}{'t'}) ? $setting::page{$setting::key}{'t'} : '';
		$main::gc = ($setting::page{$setting::key}{'c'}) ? $setting::page{$setting::key}{'c'} : '36.315125,137.504883';
	}
}
$main::gz = ($setting::page{$setting::key}{'z'}) ? $setting::page{$setting::key}{'z'} : 4 if !$main::gz;
$main::gt = ($setting::page{$setting::key}{'t'}) ? $setting::page{$setting::key}{'t'} : '' if !defined $main::gt;
$main::gc = ($setting::page{$setting::key}{'c'}) ? $setting::page{$setting::key}{'c'} : '36.315125,137.504883' if !$main::gc;

$main::mod = $main::m;

#お気に入り
my @favorites;
if ($main::fv && $this->favorites_enabled) {
	@favorites = grep($_ ne '' && $_ !~ /[^0-9]/,split(/,/,$this->read_cookie_direct('favorites')));
	$this->{'has_favorites'} = 1 if @favorites;
}

#ページヘッダ
$this->print_viewer_header;
$this->print_toolbox_top;

#---------------------------------------------------------------------
#詳細を開くウィンドウサイズ取得
#デフォルト項目のみ情報ウィンドウに表示
my($window_width,$window_height);
my $same_window = 0;
if ($this->{'has_template'}) {
	while ($setting::page{$setting::key}{'template'} =~ /<!--field[\x09\x0A\x0C\x0D\x20][^>]*id="([^>"]+)"[^>]*-->/g) {
		my $id = $1;
		if (ref $field::obj{$id} && $field::obj{$id}{'class'} eq 'xtm_detail') {
			if ($field::obj{$id}{'sameWindow'}) {
				$same_window = 1;
			} else {
				$window_width = $field::obj{$id}{'windowWidth'} if $field::obj{$id}{'windowWidth'};
				$window_height = $field::obj{$id}{'windowHeight'} if $field::obj{$id}{'windowHeight'};
			}
			last;
		}
	}
} else {
	foreach my $o (sort {$a <=> $b} keys %field::ORDER) {
		my $id = $field::ORDER{$o};
		if (ref $field::obj{$id} && $field::obj{$id}{'class'} eq 'xtm_detail') {
			if ($field::obj{$id}{'sameWindow'}) {
				$same_window = 1;
			} else {
				$window_width = $field::obj{$id}{'windowWidth'} if $field::obj{$id}{'windowWidth'};
				$window_height = $field::obj{$id}{'windowHeight'} if $field::obj{$id}{'windowHeight'};
			}
			last;
		}
		next unless ref $field::obj{$id} && !$field::obj{$id}->{'Hidden'} && $field::obj{$id}->{'Default'} && ($field::obj{$id}->{'Open'} || $this->is_secure('secret'));
		next if grep($_ eq $id,@{$this->{'selectedField'}});
		push(@{$this->{'selectedField'}},$id);
	}
}


#---------------------------------------------------------------------
#Googleマップ地図
$gmap_url = $this->escape(
	$env::javascript . '/gmap.html?' . $this->url_encoded_query(
		{
			'z'				=>	$main::gz,
			't'				=>	$main::gt,
			'c'				=>	$main::gc,
			((!$setting::page{$setting::key}{'refreshDisabled'}) ? ('r' => 1) : ()),
			'sf' => 'search-form',
			'i' => '1',
			'ns' => '1',
			(($setting::page{$setting::key}{'gmapOverView'}) ? ('om' => 1) : ()),
			(($setting::page{$setting::key}{'gmapStreetView'}) ? ('sv' => 1) : ()),
			(($setting::page{$setting::key}{'gmapSearch'}) ? ('s' => 1) : ()),
			(($same_window) ? ('tr' => 'p') : ($setting::page{$setting::key}{'gmapLinkTarget'}) ? ('tr' => $setting::page{$setting::key}{'gmapLinkTarget'}) : ('tr' => 'd')),
			(($setting::page{$setting::key}{'gmapMaxWidth'}) ? ('mw' => $setting::page{$setting::key}{'gmapMaxWidth'}) : ()),
			(($setting::page{$setting::key}{'placeListEnabled'}) ? ('lb' => 'list-box','li' => 'list') : ()),
			(($window_width) ? ('dw' => $window_width) : ()),
			(($window_height) ? ('dh' => $window_height) : ()),
			'z_field'				=>	'gz-top,gz-bottom',
			't_field'				=>	'gt-top,gt-bottom',
			'c_field'				=>	'gc-top,gc-bottom',
		}
	)
);
print '<iframe class="gmap-index" id="gmap-viewer"';
print ' src="' . $gmap_url . '"';
print ' width="' . (($setting::page{'gmap'}{'gmapWidth'}) ? $setting::page{'gmap'}{'gmapWidth'} : 400) . '"';
print ' height="' . (($setting::page{'gmap'}{'gmapHeight'}) ? $setting::page{'gmap'}{'gmapHeight'} : 400) . '"';
print ' scrolling="no" marginwidth="0" marginheight="0" frameborder="0">';
print '<a href="' . $gmap_url . '" target="_blank">新しいウィンドウで地図を開く</a>';
print '</iframe>';

#---------------------------------------------------------------------
#表示項目のリスト
if ($setting::page{$setting::key}{'placeListEnabled'}) {
	print '<div id="list-box" class="section box"><ul id="list"></ul></div>'
}

#---------------------------------------------------------------------
#フォーム
my @form = grep($_ ne 'm' && $_ ne 'k' && $_ ne 'search' && $_ ne 'and' && $_ ne 'q',@setting::form);
print $this->form_start(
	'action'	=>	$this->my_url,
	'key'		=>	'browse',
	'id'		=>	'search-form',
	'name'		=>	'search-form',
	'required'	=>	\@form
);
print '<input type="hidden" name="m" value="GMapViewer" alt="KMLViewer" />';
print '<input type="hidden" name="fav" value="' . join(',',@favorites) . '" />' if @favorites;	
if ($sc) {
	print '<fieldset id="search"><legend id="search-legend">' . (($default::english) ? 'Search' : '検索') . '</legend>';
	print '<table class="field-table" id="search-field-table"><tbody>';
	print $search_form;
	print '<tr class="tbody-start">';
	print '<td class="reset-box"><input type="button" value="' . (($default::english) ? 'Reset' : 'リセット') . '" onclick="cmonos.form.item(this.form).resetAll(\'search:\')" /></td>';
	print '<td class="submit-box">';
	print '<input type="search" placeholder="' . (($this->{'is_searched_full'}) ? ($default::english) ? 'Further Search' : '絞り込み検索' : ($default::english) ? 'Search' : '検索') . '" results="5" autosave="' . (($default::id) ? $default::id : 'tablemaker') . '" name="q" size="16" value="' . $this->escape($main::q) . '" title="' . (($this->{'is_searched_full'}) ? ($default::english) ? 'Search' : '検索キーワードでさらに絞り込みます。' : ($default::english) ? 'Search' : '検索キーワード') . '" /> ' if defined $main::q && $main::q ne '';
	if ($sc > 1) {
		print '<select name="and">';
		print '<option value="1">' . (($default::english) ? 'Matches on all requirements' : '全ての条件に一致') . '</option>';
		print '<option value="0"' . (((!defined $main::and && $setting::page{'defaultSearchOparator'} && $setting::page{'defaultSearchOparator'} eq 'OR') || ((defined $main::and || !$setting::page{'defaultSearchOparator'}) && !$main::and)) ? ' selected="selected"' : '') . '>' . (($default::english) ? 'Matches on any requirements' : 'いずれかの条件に一致') . '</option>';
		print '</select>';
	}
	print '<input type="submit" value="' . (($default::english) ? 'Search' : '検索') . '" />';
	print '</td></tr></tbody></table></fieldset>';
}
print '</form>';


#---------------------------------------------------------------------
#ページフッタ
$this->print_toolbox_bottom;
$this->print_page_return_form;
$this->print_viewer_footer;

}

######################################################################
# クラス登録
#sub import {
BEGIN {
	no warnings qw(once);

	#設定DB読み込み設定
	$setting::general = 1;					#一般設定読み込み
	$setting::deco = 1;						#テキスト装飾設定読み込み
	$setting::security = 1;					#アクセス権設定読み込み
	$setting::table = 1;						#テーブル設定読み込み
	$setting::page = 1;						#ページ設定読み込み

	$setting::field_db_name = 'inputfield';	#フィールド設定DB
	$setting::field = 2;						#フィールド設定読み込み（2=オリジナルも読み込む）
	$setting::field_style_disabled = 2;			#2=フォント設定スタイル設定を無視/1=フォント設定のみ無視
	$setting::field_tag_enabled = 'no';				#tag=タグのみ/all=全ての設定/no=タグをつけない

	#設定種キー設定
	$setting::security_key = 'browse';							#デフォルトセキュリティキー
	$setting::key = 'gmap';						#ページ設定キー

	#クッキー
	$cookie::id_enabled = 1;							#ID情報クッキー読み込み

	#デフォルトキー
	$main::k = 'gmap' if !defined $main::k || !$main::k;

	#必須フォーム
	@setting::form = ('k','m','c','f','u','uni','s','w','mod','and','search','q','fv') if !@setting::form;

	#クラス登録
	Common::class_register('gmap','GMapViewer');

	#イメージCSS
	$setting::image_css = 'tablemaker-image.css';

}

1;
