package Index;
require CMONOS::TableMaker::TMCommon;
@ISA = qw(TMCommon);
use strict;
use utf8;
######################################################################
# インデックスモジュール
# Index.pm ver1.1.3
# Copyright (C) 1999-2012 CMONOS (ENDO chihiro)
# 
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2010-06-04
######################################################################
# メイン
sub run ($) {
my $this = shift;
my($title,$mailer_check,$field_selector_enabled);
$this->use_deco;
$main::mod = $setting::page{'defaultView'} if !defined $main::mod || !$main::mod;
$main::u = $main::uni if $main::uni;
$main::u = $setting::page{'u'} if $this->is_nan($main::u);
$main::u = 20 if !$main::u;
$field_selector_enabled = (!$setting::page{'index'}{'closedf'} || $this->is_secure('revise')) ? 1 : 0;
$this->set_og_url($this->my_url);
$this->set_og_cgi_summary;

#---------------------------------------------------------------------
#承認待ち項目警告
$this->set_pending_item_alert if !defined $main::mod && !defined $main::w && !defined $main::s && $this->is_secure('tools');

$this->replace_category_list;

#ページヘッダ
$this->set_javascript(
		'cmonos.tool.toggleSearchFormMode = function (this_mode) {if (this_mode == "TableViewer" || this_mode == "CsvViewer" || this_mode == "TsvViewer" || this_mode == "VCardViewer" || this_mode == "VCard2Viewer") {'
	 . (($field_selector_enabled) ? 'document.getElementById("tableview-f").style.display = "";' : '')
	 . '} else {'
	 . (($field_selector_enabled) ? 'document.getElementById("tableview-f").style.display = "none";' : '')
	 . '}}') if $field_selector_enabled;
$this->print_page_header('index');

#フォーム
print $this->form_start(
	'key'	=>	'browse',
	'name'	=>	'input',
	'id'	=>	'tm-search'
);


#---------------------------------------------------------------------
#検索条件欄
print '<fieldset id="view-selector"><legend>' . (($default::english) ? 'View' : '表示設定') . '</legend>';


#---------------------------------------------------------------------
#カテゴリー選択
$this->print_category_selector(
	'<table class="field-table"><tbody>',
	'<tr><td class="field-name"><label for="c">' . (($default::english) ? 'Category' : 'カテゴリー') . '</label></td><td class="field">',
	'</td></tr>'
);


#---------------------------------------------------------------------
#ソート
print '<tr>';
print '<td class="field-name"><label for="s">' . (($default::english) ? 'Sort' : 'ソート') . '</label></td>';
print '<td class="field">';

print '<select id="s" name="s">';

$main::s = ($field::for{'sort'}) ? $field::for{'sort'} : ($field::for{'key'}) ? $field::for{'key'} : ($field::for{'title'}) ? $field::for{'title'} : '' if !defined $main::s || $main::s eq '';
foreach (sort {$a <=> $b} keys %field::ORDER) {
	my($id);
	$id = $field::ORDER{$_};
	next unless ref $field::obj{$id};
	$mailer_check = 1 if defined $field::obj{$id}->{'e-mail'} && $field::obj{$id}->{'e-mail'};
	next unless !$field::obj{$id}->{'Hidden'} && ($field::obj{$id}->{'Open'} || $this->is_secure('secret')) && $field::obj{$id}->sort_enabled && $field::obj{$id}->{'sortEnabled'};
	print '<option value="' . $id . '"' . ((defined $main::s && $main::s eq $id) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$id}->name,32,'I',1) . '</option>';
}
print '</select>';
print '</td></tr>';

#---------------------------------------------------------------------
#ソート順
print '<tr>';
print '<td class="field-name"><label for="w">' . (($default::english) ? 'Sort By' : 'ソート順') . '</label></td>';
print '<td class="field">';

$main::w = ($field::SORTORDER) ? $field::SORTORDER : 'ascend' if !defined $main::w || $main::w eq '';
print '<select id="w" name="w">';
print '<option value="ascend"' . ((defined $main::w && $main::w eq 'ascend') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'ascending' : '昇順') . '</option>';
print '<option value="descend"' . ((defined $main::w && $main::w eq 'descend') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'descending' : '降順') . '</option>';
print '</select>';
print '</td></tr>';

#---------------------------------------------------------------------
#表示形式/ボタン
my $m_control = '';
$m_control .= 'cmonos.tool.toggleSearchFormMode(this.options[this.selectedIndex].value);' if $field_selector_enabled;
if ($setting::page{'download'}) {
	my $filename = $default::id || 'exported';
	$filename =~ s/^_//;
	$filename .= '_data';
	$m_control .= 'cmonos.form.item(this.form).field(this).appendDownloadPathByValue({\'CsvViewer\':\'' . $filename . '.csv\',\'TsvViewer\':\'' . $filename . '.tsv\',\'VCardViewer\':\'' . $filename . '.vcf\',\'VCard2Viewer\':\'' . $filename . '.vcf\'});';
}
print '<tr>';
print '<td class="field-name"><label for="m">' . (($default::english) ? 'View' : '表示方式') . '</label></td>';
print '<td class="field">';
print '<select id="m" name="m"' . (($m_control) ? ' onchange="' . $m_control . '"' : '') . '>';
print '<option value="TableViewer"' . ((defined $main::mod && $main::mod eq 'TableViewer') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'Table' : 'テーブル表示') . '</option>';
print '<option value="GMapViewer"' . ((defined $main::mod && $main::mod eq 'GMapViewer') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'GoobleMaps' : 'Googleマップ表示') . '</option>' if $this->gmap_view_enabled;
print '<option value="TileViewer"' . ((defined $main::mod && $main::mod eq 'TileViewer') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'Tile' : 'タイル表示') . '</option>';
if ($setting::page{'download'}) {
	print '<option value="CsvViewer"' . ((defined $main::mod && $main::mod eq 'CsvViewer') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'Comma-Separated-Values (csv)' : 'カンマ区切りテキスト(csv)') . '</option>';
	print '<option value="TsvViewer"' . ((defined $main::mod && $main::mod eq 'TsvViewer') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'Tab-Separated-Values' : 'タブ区切りテキスト') . '</option>';
	if ($setting::page{'vcard'}) {
		print '<option value="VCardViewer"' . ((defined $main::mod && $main::mod eq 'VCardViewer') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'vCard (vcf)' : 'vCard 形式(vcf)') . '</option>';
		print '<option value="VCard2Viewer"' . ((defined $main::mod && $main::mod eq 'VCard2Viewer') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'vCard2.1 (vcf)' : 'vCard2.1 形式(vcf)') . '</option>';
	}
}
print '<option value="Mailer"' . ((defined $main::mod && $main::mod eq 'Mailer') ? ' selected="selected"' : '') . '>' . (($default::english) ? 'Send mail by this list.' : 'メール配信フォームを開く') . '</option>' if $mailer_check && $this->is_secure('mail');
print '</select>';
print '<div class="extra-field"><label><input type="text" size="3" name="u" id="u" value="' . $main::u . '" />' . ($default::english ? 'records per page.' : '件ずつ表示') . (($setting::page{'uLimit'}) ? ' (&lt;' . $setting::page{'uLimit'} . ')' : '') . '</label></div>' if !$setting::page{'uStatic'};
print '</td></tr>';

#---------------------------------------------------------------------
#表示項目選択
push(@main::f,$main::f) if defined $main::f && $main::f;
if ($field_selector_enabled) {
	my $size = keys %field::obj;
	$size++ if $this->is_secure('revise');
	$size = 8 if $size > 8;
	$size = 1 if $size < 1;

	print '<tr id="tableview-f">';
	print '<td class="field-name"><label for="f">' . (($default::english) ? 'Field' : '表示項目') . '</label></td>';
	print '<td class="field">';
	print ((($setting::page{'index'}{'checkboxf'}) ? '<ol class="checkbox"' : '<select id="f" name="f" size="' . $size . '" multiple="multiple"') . ' title="' . (($default::english) ? 'For Table' : 'テーブル表示時のみ有効') . '">');

	foreach (sort {$a <=> $b} keys %field::ORDER) {
		my $id = $field::ORDER{$_};
		next if !ref $field::obj{$id} || $field::obj{$id}->{'Hidden'} || (!$field::obj{$id}->{'Open'} && !$this->is_secure('secret'));
		if ($setting::page{'index'}{'checkboxf'}) {
			print '<li><label><input type="checkbox" name="f" value="' . $id . '"' . (((!@main::f && $field::obj{$id}->{'Default'}) || (@main::f && grep($_ eq $id,@main::f))) ? ' checked="checked"' : '') . ' /> ' . $this->jfold($field::obj{$id}->name,32,'I',1) . '</label></li>';
		} else {
			print '<option value="' . $id . '"' . (((!@main::f && $field::obj{$id}->{'Default'}) || (@main::f && grep($_ eq $id,@main::f))) ? ' selected="selected"' : '') . '>' . $this->jfold($field::obj{$id}->name,32,'I',1) . '</option>';
		}
	}
	if ($this->is_secure('revise')) {
		if ($setting::page{'index'}{'checkboxf'}) {
			print '<li><label><input type="checkbox" name="f" value="r"' . ((!@main::f || (@main::f && grep($_ eq 'r',@main::f))) ? ' checked="checked"' : '') . ' /> データ修正' . '</label></li>';
		} else {
			print '<option value="r"' . ((!@main::f || (@main::f && grep($_ eq 'r',@main::f))) ? ' selected="selected"' : '') . '>データ修正' . '</option>';
		}
	}
	print (($setting::page{'index'}{'checkboxf'}) ? '</ol>' : '</select>');
	print '</td></tr>';
}

#---------------------------------------------------------------------
#検索ボタン
print '<tr><td colspan="2" class="submit-box">';
print '<input type="submit" value="' . (($default::english) ? 'OK' : '表示する') . '" />';
print '</td></tr></tbody></table>';


#---------------------------------------------------------------------
#検索条件欄終了
print '</fieldset>';


#---------------------------------------------------------------------
#詳細条件欄
my($search_form,$search);
foreach (sort {$a <=> $b} keys %field::ORDER) {
	next unless ref $field::obj{$field::ORDER{$_}} && !$field::obj{$field::ORDER{$_}}->{'Hidden'} && ($field::obj{$field::ORDER{$_}}->{'Open'} || $this->is_secure('secret')) && $field::obj{$field::ORDER{$_}}->{'searchEnabled'} && $field::obj{$field::ORDER{$_}}->search_form_enabled;
	$search_form .= $field::obj{$field::ORDER{$_}}->search_form;
	$search++;
}

if (defined $search && $search) {
	print '<fieldset id="search"><legend>' . (($default::english) ? 'Search' : '詳細条件') . '</legend>';
	print '<table class="field-table"><tbody>';
	print $search_form;
	print '</tbody>';
	print '<tbody>';
	print '<tr class="tbody-start">';
	print '<td class="reset-box"><input type="button" value="' . (($default::english) ? 'Reset' : 'リセット') . '" onclick="cmonos.form.item(this.form).resetAll(\'search:\')" /></td>';
	print '<td class="submit-box">';
	print '<input type="search" placeholder="' . (($this->{'is_searched_full'}) ? ($default::english) ? 'Further Search' : '絞り込み検索' : ($default::english) ? 'Search' : '検索') . '" results="5" autosave="' . (($default::id) ? $default::id : 'tablemaker') . '" name="q" size="16" value="' . $this->escape($main::q) . '" title="' . (($this->{'is_searched_full'}) ? ($default::english) ? 'Search' : '検索キーワードでさらに絞り込みます。' : ($default::english) ? 'Search' : '検索キーワード') . '" /> ' if defined $main::q && $main::q ne '';
	if ($search > 1) {
		print '<select name="and">';
		print '<option value="1">' . (($default::english) ? 'Matches on all requirements' : '全ての条件に一致') . '</option>';
		print '<option value="0"' . (((!defined $main::and && $setting::page{'defaultSearchOparator'} && $setting::page{'defaultSearchOparator'} eq 'OR') || ((defined $main::and || !$setting::page{'defaultSearchOparator'}) && !$main::and)) ? ' selected="selected"' : '') . '>' . (($default::english) ? 'Matches on any requirements' : 'いずれかの条件に一致') . '</option>';
		print '</select>';
	}
	print '<input type="submit" value="' . (($default::english) ? 'Search' : '検索') . '" />';
	print '</td></tr></tbody></table></fieldset>';
}

print '</form>';
print $this->javascript('cmonos.tool.toggleSearchFormMode(\'' . (($main::mod) ? $main::mod : '') . '\')') if !$main::mod || $main::mod ne 'TableViewer';


#---------------------------------------------------------------------
#修正ボタン/新規登録ボタン
$this->print_mini_toolbox('bottom') if defined $setting::page{'index'}{'toolIcon'} && $setting::page{'index'}{'toolIcon'};


#---------------------------------------------------------------------
#ページフッタ
$this->print_page_return_form;
$this->print_page_footer('index');

}

######################################################################
# クラス登録
#sub import {
BEGIN {
	no warnings qw(once);

	#設定DB読み込み設定
	$setting::general = 1;					#一般設定読み込み
	$setting::deco = 1;						#テキスト装飾設定読み込み
	$setting::security = 1;					#アクセス権設定読み込み
	$setting::table = 1;						#テーブル設定読み込み
	$setting::page = 1;						#ページ設定読み込み

	$setting::field_db_name = 'inputfield';	#フィールド設定DB
	$setting::field = 2;						#フィールド設定読み込み（2=オリジナルも読み込む）
	$setting::field_style_disabled = 2;			#2=フォント設定スタイル設定を無視/1=フォント設定のみ無視
	$setting::field_tag_enabled = 'no';				#tag=タグのみ/all=全ての設定/no=タグをつけない

	#設定種キー設定
	$setting::security_key = 'browse';							#デフォルトセキュリティキー
	$setting::key = 'index';						#ページ設定キー

	#クッキー
	$cookie::id_enabled = 1;							#ID情報クッキー読み込み

	#デフォルトキー
	$main::k = 'index' if !defined $main::k || !$main::k;

	#必須フォーム
	@setting::form = ('m','k');

	#クラス登録
	Common::class_register('index','Index');

	#イメージCSS
	$setting::image_css = 'tablemaker-image.css';

}

1;
